]> git.madduck.net Git - code/vcsh.git/blobdiff - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Remove old cleanup code for `vcsh use`
[code/vcsh.git] / vcsh
diff --git a/vcsh b/vcsh
index c1b4874f5e78bcbbe5a8c8ccb2276f3ed25d23d9..2c4e7267813d633be792714f761256696908a29e 100755 (executable)
--- a/vcsh
+++ b/vcsh
 #!/bin/sh
 
-[ -n "$VCSH_DEBUG" ] && set -x
+[ -n "$VCSH_DEBUG" ]      && set -x
+[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
+[ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
 
 SELF=$(basename $0)
 
-[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
-[ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
-for check_directory in "$VCSH_BASE"
-do
-       if [ ! -d "$check_directory" ]; then
-               if [ -e "$check_directory" ]; then
-                       echo "$SELF: error: $check_directory exists but is not a directory" >&2
-                       exit 2
-               else
-                       mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
-               fi
-       fi
-done
+help() {
+       echo "usage: $SELF <args>
+
+   clone <remote> \\
+         [<repo>]       Clone from an existing repository
+   help                 Display this help text
+   delete               Delete an existing repository
+   enter                Enter repository; spawn new $SHELL
+   init <repo>          Initialize a new repository
+   list                 List all repositories
+   rename <repo> \\
+          <newname>     Rename repository
+   run <repo> \\
+       <command>        Use this repository
 
+   seed-gitignore \\
+   <repo>               Seed .gitignore.d/<repo> from git ls-files
+   setup                Set up repository with recommended settings
+
+   <repo> <git command> Special command that allows you to run git commands
+                        directly without having to type so much ;)" >&2
+}
 
 debug() {
-       [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $1"
+       [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
 }
 
 verbose() {
-       if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $1"; fi
+       if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
 }
 
-#   use <repo>     Use this repository
-#
-#   exit              Exit vcsh mode" >&2
-help() {
-       echo "usage: $SELF <args>
-
-   help              Display this help
+fatal() {
+       echo "$SELF: fatal: $1" >&2
+       exit $2
+}
 
-   list              List all repos
+error() {
+       echo "$SELF: error: $1" >&2
+}
 
-   run <repo> \\
-       <command>     Use this repository
+info() {
+       echo "$SELF: info: $1"
+}
 
-   init <repo>       Initialize a new repository
-   clone <remote> \\
-         [<repo>]    Clone from an existing repository" >&2
+clone() {
+       init
+       git remote add origin "$GIT_REMOTE"
+       git config branch.master.remote origin
+       git config branch.master.merge  refs/heads/master
+       git fetch
+       for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
+               [ -e "$object" ] &&
+                       error "'$object' exists." &&
+                       VCSH_CONFLICT=1;
+       done
+       [ "$VCSH_CONFLICT" = '1' ] &&
+               fatal "will stop after fetching and not try to merge!
+  Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
+       git merge origin/master
 }
 
-use() {
-       verbose "use() begin"
-       REPO_NAME="$1"
-       GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
+delete() {
+       old_dir="$PWD"
+       cd "$HOME"
+       use
+       info "This operation WILL DETROY DATA!"
+       files=$(git ls-files)
+       echo "These files will be deleted:
+
+$files
+
+AGAIN, THIS WILL DELETE YOUR DATA!
+To continue, type \"Yes, do as I say\""
+       read answer
+       [ "x$answer" = "xYes, do as I say" ] || exit 16
+       for file in $files; do
+               rm -f $file || info "could not delete '$file', continuing with deletion"
+       done
+       rmdir "$GIT_DIR" || info "could not delete '$GIT_DIR'"
+       cd "$old_dir"
+}
 
-       if [ ! -d "$GIT_DIR" ]; then
-               echo E: no repository found for "$REPO_NAME" >&2
-               return 2
-       fi
+enter() {
+       use
+       $SHELL
+}
 
-       export GIT_DIR
-       export GIT_WORK_TREE="$(git config --get core.worktree)"
-       export VCSH_DIRECTORY="$REPO_NAME"
-       verbose "use() end"
+git_dir_exists() {
+       [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
 }
 
 init() {
-       verbose "init() begin"
-       [ -e "$GIT_DIR" ] &&
-               echo "$SELF: fatal: $GIT_DIR exists" &&
-               return 21
+       [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
        export GIT_WORK_TREE="$HOME"
        mkdir -p "$GIT_WORK_TREE"
-       cd "$GIT_WORK_TREE" ||
-               (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-                exit 20) || exit 20
-       cd "$GIT_WORK_TREE"
+       cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
        git init
-       git config core.worktree "$GIT_WORK_TREE"
-       verbose "init() end"
-}
-
-leave() {
-       unset GIT_DIR
-       unset GIT_WORK_TREE
-       unset VCSH_DIRECTORY
+       setup
 }
 
-if [ "$1" = 'help' ] || [ "$#" -eq 0 ]; then
-       help
-       [ "$1" = 'help' ]
-       exit $?
-
-elif [ "$1" = 'list' ]; then
-       verbose "list begin"
+list() {
        for i in "$VCSH_BASE"/*.git; do
                echo $(basename "$i" .git)
        done
-       verbose "list end"
-       exit 0
-
-elif [ "$1" = 'run' ]; then
-       verbose "run begin"
-       use "$2"
-       shift 2
-       "$@"
-       leave
-       verbose "run end"
-       exit 0
-
-#elif [ "$1" = 'use' ]; then
-#      verbose "use begin"
-#      if [ -n "$ZSH_VERSION" ]; then
-#              if [ -o NO_IGNORE_EOF ]; then
-#                      export VCSH_NO_IGNORE_EOF=1
-#                      setopt IGNORE_EOF
-#              fi
-#              vcsh_exit() {
-#                      vcsh exit;
-#                      zle reset-prompt;
-#              }
-#              zle -N vcsh_exit
-#              bindkey '^d' 'vcsh_exit'
-#      fi
-#      use $2
-#      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#      verbose "use end"
-#      exit 0
-
-elif [ "$1" = 'clone' ]; then
-       verbose "clone begin"
-       GIT_REMOTE="$2"
-       REPO_NAME="$3"
-       [ -z "$REPO_NAME" ] && REPO_NAME=$(basename "$GIT_REMOTE" .git)
-       export REPO_NAME
-       export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
-       init
+}
 
-       git remote add origin "$GIT_REMOTE"
-       git config branch.master.remote origin
-       git config branch.master.merge  refs/heads/master
-       git fetch
-       for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
-               [ -e "$object" ] &&
-                       echo "$SELF: error: $object exists." &&
-                       VCSH_CONFLICT=1;
+rename() {
+       git_dir_exists
+       [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
+       mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
+
+}
+
+run() {
+       use
+       $VCSH_EXTERNAL_COMMAND
+}
+
+seed_gitignore() {
+       use
+       cd "$HOME"
+       gitignores=$(for file in $(git ls-files); do
+               while true; do
+                       echo $file; new="${file%/*}"
+                       [ "$file" = "$new" ] && break
+                       file="$new"
+               done;
+       done | sort -u)
+       tempfile=$(mktemp) || fatal "could not create tempfile" 51
+       echo '*' > "$tempfile"
+       for gitignore in $gitignores; do
+               echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
+               [ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
        done
-       [ "$VCSH_CONFLICT" = '1' ] &&
-               echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
-               echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
-               exit 3
-       git merge origin/master
-#      vcsh use $REPO_NAME
-       verbose "clone end"
-
-elif [ "$1" = 'init' ]; then
-       verbose "init begin"
-       [ -z $2 ] && help && return 0
-       export REPO_NAME="$2"
-       export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
-       init
-#      vcsh use "$REPO_NAME"
-       verbose "init end"
-
-#elif [ "$1" = 'exit' ]; then
-#      verbose "exit begin"
-#      if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
-#              unset VCSH_NO_IGNORE_EOF
-#              setopt NO_IGNORE_EOF
-#      fi
-#      leave
-#      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#      verbose "exit end"
-#      exit 0
+       diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
+               rm -f "$tempfile" &&
+               exit
+       if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
+               info "'$HOME/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'"
+               mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
+                       fatal "could not move '$HOME/.gitignore.d/$VCSH_REPO_NAME' to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
+       fi
+       mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
+               fatal "could not move '$tempfile' to '$HOME/.gitignore.d/$VCSH_REPO_NAME'" 53
+}
 
-else
-       verbose "defaulting to calling help()"
-       help
-       exit 3
+setup() {
+       use
+       git config core.worktree     "$GIT_WORK_TREE"
+       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+       git config vcsh.vcsh         'true'
+       touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+       git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+}
 
+use() {
+       git_dir_exists
+       export GIT_WORK_TREE="$(git config --get core.worktree)"
+       export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+}
+
+if [ "$1" = 'clone' ]; then
+       [ -z $2 ] && fatal "$1: please specify a remote" 1
+       export VCSH_COMMAND="$1"
+       GIT_REMOTE="$2"
+       [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+       export VCSH_REPO_NAME
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'delete' ] ||
+     [ "$1" = 'enter' ] ||
+     [ "$1" = 'init' ] ||
+     [ "$1" = 'rename' ] ||
+     [ "$1" = 'run' ] ||
+     [ "$1" = 'seed-gitignore' ] ||
+     [ "$1" = 'setup' ]; then
+       [ -z $2 ]                      && fatal "$1: please specify repository to work on" 1
+       [ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
+       [ "$1" = 'run' -a -z "$3" ]    && fatal "$1: please specify a command" 1
+       export VCSH_COMMAND="$1"
+       export VCSH_REPO_NAME="$2"
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+       [ "$VCSH_COMMAND" = 'rename' ]         && export GIT_DIR_NEW="$VCSH_BASE/$3.git"
+       [ "$VCSH_COMMAND" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$@"
+       [ "$VCSH_COMMAND" = 'seed-gitignore' ] && export VCSH_COMMAND='seed_gitignore'
+elif [ "$1" = 'list' ]; then
+       export VCSH_COMMAND="$1"
+elif [ -n "$1" ]; then
+       export VCSH_COMMAND=run
+       export VCSH_REPO_NAME="$1"
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+       [ -d $GIT_DIR ] || { help; exit 1; }
+       shift 1
+       export VCSH_EXTERNAL_COMMAND="git $*"
+else
+       # $1 is empty, or 'help'
+       help && exit
 fi
 
+for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
+do
+       if [ ! -d "$check_directory" ]; then
+               if [ -e "$check_directory" ]; then
+                       fatal "'$check_directory' exists but is not a directory" 13
+               else
+                       info "attempting to create '$check_directory'"
+                       mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
+               fi
+       fi
+done
+
+verbose "$VCSH_COMMAND begin"
+$VCSH_COMMAND
+verbose "$VCSH_COMMAND end, exiting"